package com.gihon.security.encoder;

import org.springframework.security.crypto.password.PasswordEncoder;

import java.security.MessageDigest;

/**
 * 自定义密码加密器
 */
// @Component
public class MyPasswordEncoder implements PasswordEncoder {
    // 加密方法，把请求参数提供的password数据，加密。返回加密后的字符串
    // 使用MD5传统加密。 16字节加密方式。
    @Override
    public String encode(CharSequence charSequence) {
        try {
            MessageDigest digest = MessageDigest.getInstance("MD5");
            // MD5加密算法，加密后的返回结果一定是16长度的字节数组。
            byte[] tmps = digest.digest(charSequence.toString().getBytes());
            StringBuilder builder = new StringBuilder("");
            //System.out.println("加密后的结果数组长度：" + tmps.length);
            for(byte tmp : tmps){
                String s = Integer.toHexString(tmp & 0xFF);
                if(s.length() == 1){
                    builder.append("0");
                }
                builder.append(s);
            }
            System.out.println(builder.toString());
            return builder.toString();
        }catch (Exception e){
            return null;
        }

        // 没有任何加密。就是原字符串
        // return charSequence.toString();
    }

    // 比较用户的真实密码和参数传递密码是否匹配。
    // 真实密码存在数据库中，是加密后的数据，encode方法的返回值。
    // 请求参数密码是加密前的数据，需要加密后和真实密码比较。
    // 参数charSequence - 原密码，请求参数传递的密码
    // 参数s - 真实密码，就是数据库中记录的密码。
    @Override
    public boolean matches(CharSequence charSequence, String s) {
        System.out.println(charSequence);
        System.out.println(s);

        return s.equals(encode(charSequence));
    }
}
