package com.gihon.security.handler;

import org.springframework.security.access.AccessDeniedException;
import org.springframework.security.web.access.AccessDeniedHandler;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public class MyAccessDeniedHandler implements AccessDeniedHandler {
    // 当用户无权限的时候，如何处理。
    // 通过响应，向客户端输出HTML，通用用户无权限，可以联系管理员。
    @Override
    public void handle(HttpServletRequest request, HttpServletResponse response, AccessDeniedException e) throws IOException, ServletException {
        response.setContentType("text/html;charset=UTF-8");
        // 响应状态码， 403， 无权限
        response.setStatus(HttpServletResponse.SC_FORBIDDEN);
        response.getWriter().println("<html><body style='text-align: center;'><h3>无权限，请联系管理员！</h3></body></html>");
        response.getWriter().flush();
    }
}
